#version 430 core
/*
* Copyright 2019 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
//layout(location = 2) in vec2 texCoord;

out VertexData {
	vec3 position_world;
	vec3 normal_world;
	//vec2 texCoord_world;
	out vec4 FragPosLightSpace;
} vert;

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projMatrix;
uniform mat3 normalMatrix;
uniform mat4 lightSpaceMatrix;


void main() {
	vert.normal_world = normalMatrix * normal;
	vec4 position_world_ = modelMatrix * vec4(position, 1);
	vert.position_world = position_world_.xyz;
	//vert.texCoord_world = texCoord;
	vert.FragPosLightSpace = lightSpaceMatrix * vec4(vert.position_world, 1.0);
	gl_Position = projMatrix * viewMatrix * position_world_;
}